; C64ASM.EXE
;
; GHOSTBUSTERS - KEY GENERATOR
;
; ===================================================================

* = $C000               ;  (SYS49152)


;-------------      Questo  il corpo del programma   ----------------------------


inizio                  JSR valore_x            ; chiama la routine che restituisce la somma del dei caratteri del nome
                        STA x                   ; memorizza il risultato (chiamato per convenzione "valore x")
                        STA euro_chk
                        LDX x
                        LDA soldi_hi
                        CLC
                        ADC soldi_lo            ; somma i 2 bytes dell'importo
                        BNE no_zero
                        LDA #$01                ; se la somma  0 la setta a 1 (altrimenti ROL generer sempre 0)
no_zero                 STA euro_chk
account                 JSR genera_chksum       ; chiama la routine che genera il cheksum dai 2 bytes dell'importo
                        DEX                     ; e la esegue per le dovute "x volte"
                        BNE account
                        JSR converti_account    ; esegue la routine che trasforma 2 byte di importo e 1 di cheksum in account (4 bytes)
                        RTS                     ; torna al basic


;---------------    Qui sotto ci sono le routine e la parte dati ---------------------



; routine che calcola la somma x dei caratteri del nome

valore_x                        LDA #$00
                        STA x
                        LDX #$13
continua                        LDA nome,X
                        CLC
                        ADC x                   ; somma il valore di ogni singolo carattere del nome
                        STA x
                        DEX
                        BPL continua
                        RTS                     ; al rientro trover in x la somma


; routine che genera il cheksum dai 2 bytes dell'importo

genera_chksum           LDA euro_chk            ; preleva il chksum
                        ASL A                   ; moltiplica per 2
                        EOR euro_chk            ; OR Esclusivo per se stesso
                        ASL A                   ; moltiplica per 2
                        EOR euro_chk            ; OR Esclusivo per se stesso
                        ASL A
                        ASL A                   ; moltiplica per 4
                        EOR euro_chk            ; OR Esclusivo per se stesso
                        ASL A                   ; moltiplica per 2
                        ROL euro_chk            ; sposta a sx di 1 posizione i bit del chk. Il carry della precedente ASL entra nel bit 0
                        RTS


;routine che trasforma i 3 bytes (importo HI, cheksum e Importo LO) in 4 bytes

converti_account                LDX #$02        ;
                        LDA #$00                ;
ciclo_1                 LDA soldi_hi,x          ;---------------------------------
                        LDY #$07                ;                       |
ciclo_2                 LSR A                   ;---------------------- |
                        ROR account_no+3        ;               |       |
                        ROR account_no+2        ;               |       |
                        ROR account_no+1        ;               |       |
                        ROR account_no          ;               |       |
                        PHA                     ;               |       |
                        INC counter             ;               |       |
                        LDA counter             ;               |       |
                        CMP #$03                ;               |       |
                        BNE ciclo_3             ;       esegue 3 volte  esegue 2 volte
                        LDA #$00                ;               |       |
                        STA counter             ;               |       |
                        CLC                     ;               |       |
                        ROR account_no+3        ;               |       |
                        ROR account_no+2        ;               |       |
                        ROR account_no+1        ;               |       |
                        ROR account_no          ;               |       |
ciclo_3                 PLA                     ;               |       |
                        DEY                     ;               |       |
                        BPL ciclo_2             ;---------------------- |
                        DEX                     ;                       |
                        BPL ciclo_1             ;---------------------------------
                        RTS


; Zona buffer dove memorizzare i dati

nome            .byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0   ; Utente - Memorizzare qu i caratteri del nome
soldi_hi        .byte 0                                 ; Utente - Memorizzare qu la parte alta dell'importo
euro_chk        .byte 0                                 ; Programma - registra qu valore del checksum
soldi_lo        .byte 0                                 ; Utente - Memorizzare qu la parte bassa dell'importo

x               .byte 0                                 ; Programma - registra qu valore somma dei caratteri del nome
counter         .byte 0                                 ; Programma - usato per convertire importo e chk in 4 bytes di account
account_no      .byte 0,0,0,0                           ; Programma - registra qu i 4 bytes dell'account
